/*
libmatrix.h

matrix manipulation library
version 0.02
Peter A. Cejchan, GPL
Thu Mar 25 13:13:11 EST 2004 <cej@gli.cas.cz | pac7@post.cz | pac@plan9.cz>



*/
#define MAXROWS 100
#define MAXCOLS MAXROWS
#define MAXLENGTH MAXROWS
#define MAXFLOAT 1e20
#define LINELEN 65536

typedef struct Matrix Matrix;
typedef struct iMatrix iMatrix;
typedef struct cMatrix cMatrix;
typedef struct Vector Vector;
typedef struct iVector iVector;
typedef struct Couple Couple;

extern	Biobuf bin;

struct Matrix{
	int rows, cols;
	double **x;
//	void *where;
};

struct iMatrix{
	int rows, cols;
	int **x;
};

struct Couple{
	int pred, succ;
};

struct cMatrix{
	int rows, cols;
	Couple **x;
};

struct Vector{
	int length;
	double x[MAXLENGTH];
};

struct iVector{
	int length;
	int x[MAXLENGTH];
};

// functions

int readheader(int *rows, int *cols);
int readmat(Matrix *mat);
int readimat(iMatrix *mat);
int readfreeformmat(Matrix *mat);
Matrix *allocmat(int rows, int cols);
int allocimat(iMatrix *mat, int rows, int cols);
int alloccmat(cMatrix *mat, int rows, int cols);
void writemat(Matrix *mat);
void writeimat(iMatrix *mat);
int matmax(Matrix *mat);
int mattranspose(Matrix *mat);
int imattranspose(Matrix *mat);
void matmul(Matrix *a, Matrix *b, Matrix *out);

int readvec(Vector *vec);
int readivec(iVector *vec);
int neighborpair(iVector *vec, iMatrix *mat);

void ident(Matrix *mat);
